﻿Type=Activity
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals	
	Private FlagQuit As Boolean = False
End Sub

Sub Globals
	Private ivs() As ImageView
	Private ListImageUrl As List
	Private ImageMaxIndex As Int	
	
	Private viewPhoto1 As ImageView
	Private viewPhoto2 As ImageView
	Private viewPhoto3 As ImageView
	Private viewPhoto4 As ImageView
	Private viewPhoto5 As ImageView
	Private viewPhoto6 As ImageView
	Private viewPhoto7 As ImageView
	Private viewPhoto8 As ImageView
	Private viewPhoto9 As ImageView

	Private btnBack As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)	
	Activity.LoadLayout("2")
	
	ivs = Array As ImageView(viewPhoto1, viewPhoto2, viewPhoto3, viewPhoto4, _
		viewPhoto5, viewPhoto6, viewPhoto7, viewPhoto8, viewPhoto9)
		
	ListImageUrl.Initialize
	ListImageUrl.Add("http://www.humanisoft.com/test/52404296.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/762044399.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/528643595.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/909029749.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/305792120.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/800634350.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/376315579.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/655192633.jpg")
	ListImageUrl.Add("http://www.humanisoft.com/test/188119427.jpg")
	
	For Each Link As String In ListImageUrl	
		Dim dd As DownloadData
		dd.url = Link
		dd.EventName = "dd"
		dd.Target = Me
		CallSubDelayed2(DownloadService, "StartDownload", dd)			
	Next
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub dd_Progress(Progress As Long, Total As Long)
	
End Sub

Sub dd_Complete(Job As HttpJob)
	If FlagQuit = True Then
		Job.Release
		Return		
	End If
	
	Log("Job completed: " & Job.Success)
	If Job.Success Then
		ivs(ImageMaxIndex).Bitmap = Job.GetBitmap
		ivs(ImageMaxIndex).Gravity = Gravity.FILL
		ImageMaxIndex = ImageMaxIndex + 1
	End If
	Job.Release
End Sub

Sub btnBack_Click
	FlagQuit = True
	For Each Link As String In ListImageUrl
		CallSubDelayed2(DownloadService, "CancelDownload", Link)
	Next
	Activity.Finish
End Sub

